;***************************************************************************
;* Compiler AVR Studio 4
;*  ,   220     
;* Fcpu = 1600 KHz;	Tcycle = 0.625 uS
;*   DS1821.
;*     (0x00)  (0x01)  
;;***************************************************************************

.INCLUDE "tn15def.inc" 

;***************************************************************************
;* REGISTER DEFINITIONS
;***************************************************************************
.def 	rGenPurp1 = r1
.def 	rGenPurp2 = r2

		
.def 	rZero = r5
.def 	rKeyState = r12	;<>0-  , 

.def 	rTGenPurp9 = r13	

.def 	rGenPurp10 = r16
.def 	rGenPurp11 = r17
.def 	rGenPurp12 = r18

.def 	rADC100 = r19
.def 	rADCValue = r23
;.def 	rADCValue_Min = r9
;.def 	rADCValue_Max = r7	
;.def 	rBuzzerState = r4	;   . 0-; 255- .    

.def 	rTemperat = r21
.def 	rTemperatOld = r8
.def 	rTemperatSign = r3	
.def 	rTemperatMin = r10	
.def 	rTemperatMax = r11
.def 	rTemperatMinDay = r14	
.def 	rTemperatMaxDay = r15
.def 	rTemperatDirect = r20	;0x8x- , 0xAx- , 0x6x- 
	
.def 	LANGenPurp1 = r22

.def 	LANGenPurp3 = r24
.def 	LANGenPurp4 = r25
.def 	LANGenPurp5 = r6
	
;***************************************************************************
;*
;* PORT DEFINITIONS
;*
;***************************************************************************

.equ	csLEDStrob = PB3
.equ	csLEDData = PB4
.equ	csLAN_IO = PB0
.equ	csMicrofon = PB1
.equ	csBuzzer = DDB5
.equ	csLAN_IO_CMD_READ_TEMPER = 0xAA
.equ	csLAN_IO_CMD_READ_STATUS = 0xAC
.equ	csLAN_IO_CMD_WRITE_STATUS = 0x0C
.equ	csLAN_IO_CMD_STRT_CONV = 0xEE
.equ	csLAN_IO_CMD_STOP_CONV = 0x22
.equ 	csLAN_IO_ERR_NOT_PRESENT = 0
.equ 	csLAN_IO_ERR_CONFIG = 1
.equ 	csLAN_IO_ERR_LINE_SHORT = 99
;.equ 	csMicrofonDetectTime = 2		;MicrofonDetectTime = 1sec /(1/Timer1 max_freq)
.equ 	csLightONTime = 250		;LightONTime = 41sec /(1/Timer1 max_freq)
.equ 	csAdditionInfIndicateTime = 31		;= 5sec /(1/Timer1 max_freq). Max 63
.equ 	csAddInfCommMinTemper = 0x00		;0- 
.equ 	csAddInfCommMaxTemper = 0x40		;1- 
.equ 	csAddInfCommMinTempDay = 0x80		;2-   
.equ 	csAddInfCommMaxTempDay = 0xC0		;3-   
.equ 	csCheckTemperDirectTime = 0x80	; = 128*41sec = 87min
.equ 	csTemperDirectMiddle = 0x80
.equ 	csTemperDirectDiff = 0x20
.equ 	csADCmin = 165 - 44			;  ( 44)
.equ 	csADCmax = 260 - 44			;  ( 44)
;***************************************************************************
;*
;* CONSTANT DEFINITIONS
;*
;***************************************************************************

.CSEG

;---------------------------------------------------------        
.ORG 0
        rjmp    main

.ORG OC1addr
        rjmp    lbTimer1CmpInt	
		
;.ORG ACIaddr
;       rjmp    AnlgCompInt
;---------------------------------------------------------        

				;     0		1	  2		3	  4		5	  6	 	7	  8		9	
LEDconst: 		.DB 0x03, 0x9F, 0x25, 0x0D, 0x99, 0x49, 0x41, 0x1F, 0x01, 0x09;


;---------------------------  MAIN -----------------------------
main:   
		ldi rGenPurp10, 0x86
		out	OSCCAL,rGenPurp10
		clr rZero		 
		out PORTB, rZero 	; Pull-Up rez
		ldi rGenPurp10, (1 << DDB3) + (1 << DDB5)	; PB3, PB5   
		out DDRB, rGenPurp10
		ldi rGenPurp10, (1 << PUD) 			; Pull-Up rez
		out MCUCR, rGenPurp10

lbreadEEPROM_minT:					;  
		sbic EECR, EEWE			;min temperature
		rjmp lbreadEEPROM_minT
		ldi rGenPurp10, 0		
		out EEAR, rGenPurp10
		sbi EECR, EERE
		in rTemperatMin, EEDR
lbreadEEPROM_maxT:
		sbic EECR, EEWE			;max temperature
		rjmp lbreadEEPROM_maxT
		ldi rGenPurp10, 1		
		out EEAR, rGenPurp10
		sbi EECR, EERE
		in rTemperatMax, EEDR	
;lbreadEEPROM_maxU:		
;		sbic EECR, EEWE			;min ADC voltage
;		rjmp lbreadEEPROM_maxU
;		ldi rGenPurp10, 0x10		
;		out EEAR, rGenPurp10
;		sbi EECR, EERE
;		in rADCValue_Min, EEDR
;lbreadEEPROM_minU:
;		sbic EECR, EEWE			;max ADC voltage
;		rjmp lbreadEEPROM_minU
;		ldi rGenPurp10, 0x11		
;		out EEAR, rGenPurp10
;		sbi EECR, EERE
;		in rADCValue_Max, EEDR
		
;		inc rADCValue_Min		;  0xFF   
;		brne lbCheckADCmax 
;		ldi rGenPurp10, csADCmin + 1
;		mov rADCValue_Min, rGenPurp10
;lbCheckADCmax:
;		dec rADCValue_Min			
;		inc rADCValue_Max		;  0xFF   
;		brne lbCheckADC_end 
;		ldi rGenPurp10, csADCmax + 1
;		mov rADCValue_Max, rGenPurp10
lbCheckADC_end:
;		dec rADCValue_Max

		;ADC chanel - 1, Uref = Uint2.56, ADCfreq = CK/16,   
		ldi rGenPurp10, (1<<ADLAR) + (1<<ACIE) + (1<<REFS1) + (1<<MUX0)
		out ADMUX, rGenPurp10
		ldi rGenPurp10, (1<<ADEN) + (1<<ADPS2)
		out ADCSR, rGenPurp10

		;Analog comparator, Uref = Uint1.22,     "1"  "0"
		ldi rGenPurp10, (1<<ACBG)
		out ACSR, rGenPurp10

		;Timer 1 clock freq = CK / 1024 = 1600KHz / 1024 = 1562.5KHz: max = 6.1Hz				
		ldi rGenPurp10, (1<<OCIE1A)			;  Timer1
		out TIMSK, rGenPurp10
		ldi rGenPurp10, (1<<CTC1) + (1<<CS13) + (1<<CS12) + (1<<CS11) + (1<<CS10)  		
		out TCCR1, rGenPurp10
		ldi rGenPurp10, 0xff
		out OCR1A, rGenPurp10
		clr XL
		clr XH
		clr rTGenPurp9
		clr rKeyState
		ldi rTemperatDirect, csTemperDirectMiddle

		set						;call SettDS1821 on first time 
		clr rGenPurp11
lbEraseEEPROM:
		ldi rGenPurp10, 10		;     
		sbi DDRB, csLEDData		;    . 
lbEraseEEPROM1:
		cbi PORTB, csLEDData 		; LEDData  0
		nop
		nop
		nop
		sbic PINB, PINB2		;check that same as LEDData
		rjmp lbMainStart
		sbi PORTB, csLEDData		; LEDData  1
		nop
		nop
		nop
		sbis PINB, PINB2		;check that same as LEDData
		rjmp lbMainStart
		dec rGenPurp10
		brne lbEraseEEPROM1
		
		tst rGenPurp11
		brne lbEraseEEPROM

		ldi rGenPurp10, 0
		ldi rGenPurp11, 25
lbEraseEEPROM2:
		cbi DDRB, csLEDData		;    . 
lbEraseEEPROM2_1:
		sbic EECR, EEWE	; 
		rjmp lbEraseEEPROM2_1
		out EEAR, rGenPurp10
		out EEDR, rGenPurp11
		sbi EECR, EEMWE
		sbi EECR, EEWE
		inc rGenPurp10
lbEraseEEPROM3:
		sbic EECR, EEWE	; 
		rjmp lbEraseEEPROM3
		out EEAR, rGenPurp10
		out EEDR, rGenPurp11
		sbi EECR, EEMWE
		sbi EECR, EEWE		
		rjmp lbEraseEEPROM
		
lbMainStart:
		sei						;  

lbMainLoop:
		brtc lbMainLoop1   		;if any error(T=1) on LAN then resettings  
;----------------------		  		
  ;      rcall SettDS1821		;Settings fo DS1821. Start on 1-Wire mode, continuos conversion mode. 
lbSettDS1821:	;change settings for DS1821
		rcall lbresLAN 			;RESET on line. 
		brts lbMainLoop1			;if any error then return
lbSett_bgn:	;begin settings
 		ldi LANGenPurp4, csLAN_IO_CMD_WRITE_STATUS 
		rcall lbwr8LAN
		ldi LANGenPurp4, 0		;Start on 1-Wire mode, continuos conversion mode.
		rcall lbwr8LAN
		rcall lbrd8LAN
		andi LANGenPurp4, 0x05	;Check bits 1SHOT & T\R in config register ofDS1821
		breq lbMainLoop1 
		set						;true if error settings config register
		ldi rTemperat, csLAN_IO_ERR_CONFIG
lbStartConv:
	;start conversions
		rcall lbresLAN 			;RESET on line. 
		brts lbMainLoop1			;if any error then return
 		ldi LANGenPurp4, csLAN_IO_CMD_STRT_CONV 
		rcall lbwr8LAN
;----------------------
lbMainLoop1:
		;  
		; YH 7  6 ,   LED (0- , 1- , 2-   , 
								 ;3-   ).   5  0 , .  
								 ;   10 
		mov rGenPurp10, YH
		andi rGenPurp10, 0x3F 	;  7, 6 
		cpi rGenPurp10, csAdditionInfIndicateTime				
		brlo lbKeyCheck
		clr YH
lbKeyCheck:
		ldi rGenPurp10, 10		;     
		sbi DDRB, csLEDData		;    . 
lbKeyCheck1:
		cbi PORTB, csLEDData 		; LEDData  0
		nop
		nop
		nop
		sbic PINB, PINB2		;check that same as LEDData
		rjmp lbKeyCheckNoKey
		sbi PORTB, csLEDData		; LEDData  1
		nop
		nop
		nop
		sbis PINB, PINB2		;check that same as LEDData
		rjmp lbKeyCheckNoKey
		dec rGenPurp10
		brne lbKeyCheck1
		tst rKeyState 
		brne lbAnlgComp
		andi YH, 0xC0
		ldi rGenPurp10, 0x41	;  YH  ,   
		add YH, rGenPurp10
		inc rKeyState
		rjmp lbAnlgComp
lbKeyCheckNoKey:
		clr rKeyState
;----------------------
		;   
lbAnlgComp:
		cbi DDRB, csLEDData		;    .    
		cbi DDRB, csMicrofon		;    .
		cpi YL, csLightONTime
		brlo lbAnlgComp_ch
		cbi PORTB, csMicrofon		;   0,  
		cpi YL, csLightONTime + 2	;     
		brlo lbAnlgComp_EOff
		ldi YL, 0		;stop increment by timer
lbAnlgComp_EOff:
		rjmp lbAnlgComp_End

lbAnlgComp_ch:
		nop
		nop
		nop
		nop
		sbic ACSR, ACO			;    	
		rjmp lbAnlgComp_End	
		;Any Noise. Signal comparator is "0"
		ldi YL, 1		;start increment by timer	 
		sbi PORTB, csMicrofon		;   1,  
		
lbAnlgComp_End:
		sbi DDRB, csMicrofon		;    .

;----------------------	
lbADCbgn:	;   220			
		sbi ADCSR, ADSC
lbADCWait:sbic ADCSR, ADSC
		rjmp lbADCWait
		in rADCValue, ADCH	
		cpi rADCValue, csADCmin
		brsh lbADC_ch_max
		ldi rGenPurp11, csADCmin
		sub rGenPurp11, rADCValue
		rjmp lbADC_dif
lbADC_ch_max:
		cpi rADCValue, csADCmax
		brlo lbADC_inRange
		mov rGenPurp11, rADCValue
		subi rGenPurp11, csADCmax
		rjmp lbADC_dif
lbADC_inRange:
		clr rGenPurp11
		rjmp lbADC_Buzz
lbADC_dif:		;        220,    
		cpi rGenPurp11, 5
		brsh lbADC_dif15
		ldi rGenPurp11, 0x11	;  
		rjmp lbADC_Buzz
lbADC_dif15:
		cpi rGenPurp11, 10
		brsh lbADC_dif20
		ldi rGenPurp11, 0x02	;  
		rjmp lbADC_Buzz
lbADC_dif20:
		ldi rGenPurp11, 0x01	;  
lbADC_Buzz:			; 
		tst rGenPurp11
		breq lbADC_Buzz_Off
		mov rGenPurp10, rGenPurp11	
		and rGenPurp11, XL
		cp rGenPurp11, rGenPurp10
		breq lbADC_Buzz_On
lbADC_Buzz_Off:
		cbi DDRB, csBuzzer		;    .  
		rjmp lbReadTemper
lbADC_Buzz_On:
		sbi DDRB, csBuzzer		;    .  
;----------------------
lbReadTemper:	;read Temperature from DS1821  
		cpi  XL, 0x04			;indicate in 0.7 sec
		brsh MakeIndicate
		rjmp lbMainLoop
MakeIndicate:
		clr XL

		rcall lbresLAN 			;RESET on line.
		brts lbRdTmp_end			;if any error then JUMP
lbRdTmp_bgn:	;begin read
 		ldi LANGenPurp4, csLAN_IO_CMD_READ_TEMPER 
		rcall lbwr8LAN
		rcall lbrd8LAN
		mov rTemperat, LANGenPurp4
		brts lbRdTmp_end			;if any error then JUMP
lbIndAddInf:
        tst YH
		breq lbTmpMin			;  ,  TmpMinDay 
		mov rGenPurp10, YH
		andi rGenPurp10, 0xC0 	;  7, 6 
		brne lbIndAddInfComm1
lbIndAddInfComm0:		
		mov rTemperat, rTemperatMax		;  	
		rjmp lbRdTmp_end
lbIndAddInfComm1:
		cpi rGenPurp10, csAddInfCommMaxTemper	
		brne lbIndAddInfComm2  
		mov rTemperat, rTemperatMinDay		;    	
		rjmp lbRdTmp_end
lbIndAddInfComm2:
		cpi rGenPurp10, csAddInfCommMinTempDay	
		brne lbIndAddInfComm3
		mov rTemperat, rTemperatMaxDay		;     
		rjmp lbRdTmp_end
lbIndAddInfComm3:		
		mov rTemperat, rTemperatMin		;   	
		rjmp lbRdTmp_end
lbTmpMin:	
		cp rTemperat, rTemperatMin
		brge lbTmpMax
		ldi rGenPurp10, 0		;min temperature
		mov rTemperatMin, rTemperat
		rjmp lbEEPBusy
lbTmpMax:	
		cp rTemperatMax, rTemperat
		brge lbRdTmp_end
		ldi rGenPurp10, 1		;max temperature
		mov rTemperatMax, rTemperat
lbEEPBusy:sbic EECR, EEWE	;   (0x00)  (0x01)  
		rjmp lbEEPBusy
		cli
		out EEAR, rGenPurp10
		out EEDR, rTemperat
		sbi EECR, EEMWE
		sbi EECR, EEWE
		sei
lbRdTmp_end:	
        

;----------------------	

lbIndAddInf_ADC:
		
        tst YH
		breq lbCheckTemperDirect			;  ,  lbCheckTemperDirect 
		mov rGenPurp10, YH		;1-   , 2-   ,
								;3-  , 4- 
		andi rGenPurp10, 0xC0 	;  7, 6 
		brne lbIndAddInfComm1_ADC
lbIndAddInfComm0_ADC:
		ldi rADCValue, 104 - 44		;  	
		rjmp lbCheckTemperDirect
lbIndAddInfComm1_ADC:
		cpi rGenPurp10, csAddInfCommMaxTemper	
		brne lbIndAddInfComm2_ADC
		ldi rADCValue, 101 - 44		;    	
		rjmp lbCheckTemperDirect
lbIndAddInfComm2_ADC:
		cpi rGenPurp10, csAddInfCommMinTempDay	
		brne lbIndAddInfComm3_ADC
		ldi rADCValue, 102 - 44		;    
		rjmp lbCheckTemperDirect
lbIndAddInfComm3_ADC:
		ldi rADCValue, 103 - 44		;  	

lbCheckTemperDirect:
;ldi LANGenPurp4, 25
;ldi rGenPurp10, 80
;mov rTemperatOld, rGenPurp10
;clt
		ser rGenPurp12
		brts lbTemperDirectOut			;if any error then light on both LED
		ldi rGenPurp10, 55		;   +55
		add LANGenPurp4, rGenPurp10 
		cp LANGenPurp4, rTemperatOld	;     
		brne lbTemperDirectDiff		;    csCheckTemperDirectTime
		tst XH						;   XH ,  
		brne lbTemperDirectEq
		inc XH			
lbTemperDirectEq:				
		mov rGenPurp12, rTemperatDirect		;    LED
		cpi XH, csCheckTemperDirectTime
		brlo lbTemperDirectOut			;       2 
		clr rGenPurp12				;  csCheckTemperDirectTime,   LED	
		clr XH
		clr rTGenPurp9
		ldi rTemperatDirect, csTemperDirectMiddle
		rjmp lbTemperDirectOut

lbTemperDirectDiff:		; ,  dec rTemperatDirect,  ,  inc rTemperatDirect
		ldi rGenPurp10, 0x10
		mov rTemperatOld, LANGenPurp4	;  
		brlo lbTemperDirectDown

lbTemperDirectUp:
		add rTemperatDirect, rGenPurp10		 
		rjmp lbTemperDirectCheck
lbTemperDirectDown:
		sub rTemperatDirect, rGenPurp10	

lbTemperDirectCheck:
		mov rGenPurp12, rTemperatDirect	;    2   rTemperatDirect = 0x8x
		mov rGenPurp11, rTemperatDirect
		andi rGenPurp11, 0xF0			;   
		subi rGenPurp11, csTemperDirectMiddle
		breq lbTemperDirectZero
		brmi lbTemperDirectMin
		cpi rGenPurp11, csTemperDirectDiff		; .  >= 2     
		brlo lbTemperDirectOut
		ldi rGenPurp12, 0x02	; " "
		mov rTemperatMaxDay, rTemperat		;    
		andi rTemperatDirect, 0x0F			;   
		ori rTemperatDirect, csTemperDirectMiddle + csTemperDirectDiff
		clr XH				; -     XH
		clr rTGenPurp9
		rjmp lbTemperDirectOut
lbTemperDirectMin:
		neg rGenPurp11
		cpi rGenPurp11, csTemperDirectDiff		; .  >= 2     
		brlo lbTemperDirectOut
		ldi rGenPurp12, 0x01	; " "
		mov rTemperatMinDay, rTemperat		;    
		andi rTemperatDirect, 0x0F			;   
		ori rTemperatDirect, csTemperDirectMiddle - csTemperDirectDiff
		clr XH				; -     XH
		clr rTGenPurp9
		rjmp lbTemperDirectOut
lbTemperDirectZero:
		clr rGenPurp12				; rTemperatDirect = 0x8x   LED

lbTemperDirectOut:
		;  LEDData   
			;   2- 
		andi rTemperatDirect, 0xF0			;   
		andi rGenPurp12, 0x03 			;  2  
		or rTemperatDirect, rGenPurp12
		sbi DDRB, csLEDData		;    .
		ldi rGenPurp10, 2
lbTemperDirectOutLoop:	
		lsr rGenPurp12
		brcc lbTemperDirectOut_0
		sbi PORTB, csLEDData		; LEDData  1
		rjmp lbTemperDirectOut_S
lbTemperDirectOut_0:
		cbi PORTB, csLEDData 		; LEDData  0
		nop
		nop	
lbTemperDirectOut_S:
		sbi PORTB, csLEDStrob		; LEDStrob  1
		nop
		nop
		dec rGenPurp10
		cbi PORTB, csLEDStrob 		; LEDStrob  0
		brne lbTemperDirectOutLoop
				

lbADCConv:	
;mov rADCValue, XH	
		;   
		
		cpi rADCValue, 156;200
		brlo lbCheck100
		subi rADCValue, 156;200		; rADCValue     
		ldi rADC100, 2			; rADC100  
		rjmp lbLEDScreen_
lbCheck100:
		cpi rADCValue, 56;100
		brlo lbCheck10
		subi rADCValue, 56;100		; rADCValue     
		ldi rADC100, 1			; rADC100  
		rjmp lbLEDScreen_
lbCheck10:
		clr rADC100				;  
		ldi rGenPurp10, 44
		add rADCValue, rGenPurp10
			
		
		; rADCValue  .-  
lbLEDScreen_:
		 
		ldi rGenPurp10, 9
		ldi rGenPurp11, 89
lbLSBCDH_: cp rGenPurp11, rADCValue		; 
		brlo lbLSBCDL_
		subi rGenPurp11, 10
		dec rGenPurp10
		brne lbLSBCDH_

lbLSBCDL_: 
		inc rGenPurp11
		mov rGenPurp1, rGenPurp10		;
		sub rADCValue, rGenPurp11
		ldi rGenPurp11, 1 			; = 1,   ,  = 0,   

lbloopLS_: 
		ldi ZH, ((LEDconst >> 7) & 0x00FF)
		ldi ZL, ((LEDconst << 1) & 0x00FF)
		mov rGenPurp2, rGenPurp1			
		cpse rGenPurp11, rZero		; 1  
		mov rGenPurp2, rADCValue
		add ZL, rGenPurp2			;   
		adc ZH, rZero
		lpm							;   LED  rGenPurp0
		mov rGenPurp12, r0
		tst rGenPurp11				; ,   2,  rADCValue > 200,   1,  rADCValue > 100
		breq lbloopLS10_
		cpi rADC100, 2			;if rADCValue = 2 then light 2 on first LED
		brne lbloopLS0_
		cbr rGenPurp12, 1			;Light A,B,G,E,D (2) segment on LED
		rjmp lbloopLS0_
lbloopLS10_:
		cpi rADC100, 1			;if rADCValue = 1 then light 1 on first LED
		brne lbloopLS0_
		cbr rGenPurp12, 1			;Light B,C (1) segment on LED
lbloopLS0_:
		ldi rGenPurp10, 8
lbloopLS1_:	
		lsr rGenPurp12
		brcc lbLEDDtCl_
		sbi PORTB, csLEDData		; LEDData  1
		rjmp lbLEDStrb_
lbLEDDtCl_:cbi PORTB, csLEDData 		; LEDData  0
		nop
		nop	
lbLEDStrb_:sbi PORTB, csLEDStrob		; LEDStrob  1
		nop
		nop
		dec rGenPurp10
		cbi PORTB, csLEDStrob 		; LEDStrob  0
		brne lbloopLS1_
		
		tst rGenPurp11
		breq lbLEDScreen
		dec rGenPurp11	
		rjmp lbloopLS_
;----------------------	
lbLEDScreen:	
		; rTemperat  .-  
		clr rTemperatSign
		sbrs rTemperat, 7			;if temper is less than zero. 7-bit sign bit
		rjmp lbLEDScreen1
		inc rTemperatSign			;if rTemperat < 0 then rTemperatSign = 0x01 else rTemperatSign = 0
		neg rTemperat
lbLEDScreen1:
		ldi rGenPurp10, 9
		ldi rGenPurp11, 89
lbLSBCDH: 
		cp rGenPurp11, rTemperat		; 
		brlo lbLSBCDL
		subi rGenPurp11, 10
		dec rGenPurp10
		brne lbLSBCDH

lbLSBCDL: inc rGenPurp11
		mov rGenPurp1, rGenPurp10		;
		sub rTemperat, rGenPurp11
		ldi rGenPurp11, 1 			; = 1,   ,  = 0,   

lbloopLS: 
		ldi ZH, ((LEDconst >> 7) & 0x00FF)
		ldi ZL, ((LEDconst << 1) & 0x00FF)
		mov rGenPurp2, rGenPurp1			
		cpse rGenPurp11, rZero		; 1  
		mov rGenPurp2, rTemperat
		add ZL, rGenPurp2			;   
		adc ZH, rZero
		lpm					;   LED  rGenPurp0
		mov rGenPurp12, r0
		brtc lbloopLS01
		cbr rGenPurp12, 1			;if T=1 then Light on E (error) sign on LED.      
lbloopLS01:			
		tst rGenPurp11				; 1  
		breq lbloopLS0
		cpse rTemperatSign, rZero		;if rTemperatSign <> 0 then MINUS
		cbr rGenPurp12, 1			;Light on minus sign on LED
		
lbloopLS0:
		ldi rGenPurp10, 8
lbloopLS1:	
		lsr rGenPurp12
		brcc lbLEDDtCl
		sbi PORTB, csLEDData		; LEDData  1
		rjmp lbLEDStrb
lbLEDDtCl:cbi PORTB, csLEDData 		; LEDData  0
		nop
		nop	
lbLEDStrb:sbi PORTB, csLEDStrob		; LEDStrob  1
		nop
		nop
		dec rGenPurp10
		cbi PORTB, csLEDStrob 		; LEDStrob  0
		brne lbloopLS1
		
		tst rGenPurp11
		breq lbLEDEnd
		dec rGenPurp11	
		rjmp lbloopLS
lbLEDEnd:	cbi DDRB, csLEDData		;    . 
		rjmp lbMainLoop
				
;---------------------------  MAIN -----------------------------
		

;---------------------------  MicroLAN -----------------------------
lbDelayLAN: 	;delay on 16 + ((LANGenPurp16 - 1) * 4) cycles.  Tcycle = 0.625 uS. 
			;Delay = 10uS + ((LANGenPurp16 - 1) * 2.5uS). LANGenPurp16 must be creater than 0
		;nop
		nop
		dec LANGenPurp1	;(ldi)1+(call)4+  (nop)1+(dec)1+ (brne)1+(nop*4)4 +(ret)4 = 16	
		brne lbDelayLAN		;loop = (nop)1+(dec)1+ (brne)2 = 4
		ret
;----------------------
lbresLAN:		;RESET on line. Return in flag T, false if OK; true if any error; 
		cli						;  
		clt						;#0 if OK
		sbi DDRB, csLAN_IO		;    .  
   		cbi PORTB, csLAN_IO 		; LAN_IO  0
		ldi LANGenPurp1, 253	;delay on 640uS
		rcall lbDelayLAN
		cbi DDRB, csLAN_IO		;    .  
		ldi LANGenPurp1, 23		;delay on 65uS
		rcall lbDelayLAN
		sbis PINB, csLAN_IO		;if 1 then sensor is not present
		rjmp lbresLAN_1
		set						;#1 if sensor not present
		ldi rTemperat, csLAN_IO_ERR_NOT_PRESENT
		sei						;  	
		ret
lbresLAN_1:	;Check line short to ground
		ldi LANGenPurp1, 197	;delay on 500uS
		rcall lbDelayLAN
		sbic PINB, csLAN_IO		;if 1 then OK
		rjmp lbresLAN_2
		set						;if 0 then short to ground
		ldi rTemperat, csLAN_IO_ERR_LINE_SHORT
lbresLAN_2:
		sei						;  
		ret
;----------------------
lbwr8LAN:	;write 8 bit (1 byte) to LAN_IO. Input byte in LANGenPurp4
		cli						;  
		ldi LANGenPurp3, 8		;init bit counter
lbwr8LANloop:
		lsr LANGenPurp4
		brcc lbwr8LAN_0
			;if C=1 then write 1 to LAN_IO
;write 1 to LAN_IO
		sbi DDRB, csLAN_IO		;    .  
		nop
		ldi LANGenPurp1, 2
lbloWr1LAN1:
		dec LANGenPurp1
		brne lbloWr1LAN1			;delay on 4.375uS
		cbi DDRB, csLAN_IO		;    .  
		ldi LANGenPurp1, 27		;delay on 75uS
		rcall lbDelayLAN
		rjmp lbwr8LANloop1
lbwr8LAN_0:
			;if C=0 then write 0 to LAN_IO
	;write 0 to LAN_IO
		sbi DDRB, csLAN_IO		;    .  
		ldi LANGenPurp1, 29		;delay on 80uS
		rcall lbDelayLAN
		cbi DDRB, csLAN_IO		;    .  
		
lbwr8LANloop1:
		dec LANGenPurp3
		brne lbwr8LANloop
		sei						;  
		ret

lbrd8LAN:	;read 8 bit (1 byte) from LAN_IO. Readed byte in LANGenPurp4
		cli						;  
		ldi LANGenPurp3, 8		;init bit counter
lbrd8LANloop:
	;Read 1 bit from line. Return in C flag
		sbi DDRB, csLAN_IO		;    .  
		clc						;   C						
		nop
		nop						;delay on 1.875uS
		cbi DDRB, csLAN_IO		;    .  		
		ldi LANGenPurp1, 3		;delay on 15uS
		rcall lbDelayLAN
		sbic PINB, csLAN_IO		
		sec						;if 1 then set C flag
		ldi LANGenPurp1, 20		;delay on 57.5uS
		rcall lbDelayLAN
		ror LANGenPurp4
		dec LANGenPurp3
		brne lbrd8LANloop
		sei						;  
		ret
;---------------------------  MicroLAN -----------------------------

;---------------------------  Interrupt Timer 1 -----------------------------

lbTimer1CmpInt:
		inc XL

		inc rTGenPurp9
		brne lbTimer1CmpIntYL
		tst XH
		breq lbTimer1CmpIntYL
		inc XH 

lbTimer1CmpIntYL:	
		tst YL			;if <> 0 then increment
		breq lbTimer1CmpIntYH
		inc YL

lbTimer1CmpIntYH:		
		tst YH			;if <> 0 then increment
		breq lbTimer1CmpIntExit
		inc YH
		
lbTimer1CmpIntExit:
  		reti
;---------------------------  Interrupt Timer 1 -----------------------------
